<master>
<property name="doc(title)">@page_title;literal@</property>
<property name="main_navbar_label">timesheet2_timesheet</property>
<property name="left_navbar">@left_navbar_html;literal@</property>


<div id=@task_editor_id@>
<script type='text/javascript' <if @::__csp_nonce@ not nil>nonce="@::__csp_nonce;literal@"</if>>

Ext.Loader.setPath('PO', '/sencha-core');
Ext.Loader.setPath('PO.model', '/sencha-core/model');
Ext.Loader.setPath('PO.store', '/sencha-core/store');
Ext.Loader.setPath('PO.class', '/sencha-core/class');
Ext.Loader.setPath('PO.view', '/sencha-core/view');
Ext.Loader.setPath('PO.controller', '/sencha-core/controller');
Ext.Loader.setPath('PO.tsweekly', '/intranet-timesheet2-weekly/js');
Ext.Loader.setConfig({disableCaching: false});  // Disable the ?_dc=123456789 parameter from loader

Ext.require([
    'Ext.data.*',
    'Ext.grid.*',
    'Ext.tree.*',
    'PO.Utilities',
    'PO.controller.ResizeController',		// Handles "Maximize" button etc.
    'PO.controller.StoreLoadCoordinator',
    'PO.model.timesheet.TimesheetTask',
    'PO.model.timesheet.Hour',
    'PO.model.project.Project',
    'PO.store.CategoryStore',
    'PO.store.project.ProjectMainStore',
    'PO.store.timesheet.HourStore',
    'PO.store.timesheet.TaskTreeStore',
    'PO.tsweekly.HourWeeklyController',
    'PO.tsweekly.HourWeekly',
    'PO.tsweekly.HourWeeklyStore',
    'PO.view.field.POComboTree'
]);

function launchTimesheetWeeklyLogging(){
    // -----------------------------------------------------------------------
    // Stores
    var hourStore = Ext.StoreManager.get('hourStore');
    var taskTreeStore = Ext.StoreManager.get('taskTreeStore');
    var projectStore = Ext.StoreManager.get('projectMainStore');

    // -----------------------------------------------------------------------
    // Row-Editor for the hour grid
    var rowEditing = Ext.create('Ext.grid.plugin.RowEditing', {
        clicksToEdit: 1,
        clicksToMoveEditor: 1,
        listeners: {
            edit: function(editor, context, eOpts) {
                // Check that the endTime is later than startTime
                context.record.save();
            }
        }
    });

    var sumType = function(hourArray, dataIndex) {
        var sum = 0;
        for (var i = 0; i < hourArray.length; i++) {
            var vString = hourArray[i].get(dataIndex);
            var vFloat = parseFloat(vString);
            if (!!vFloat) sum = sum + vFloat;
        }
        return sum;
    };

    var sumRenderer = function(value, summaryData, dataIndex) {
        var type = typeof(value);
        if ("number" == type) {
            return Math.round(value * 100) / 100;
        }
        return value;
    };
    
    var hourGrid = Ext.create('Ext.grid.Panel', {
        store: hourStore,
        layout: 'fit',
        region: 'center',
        columnLines: true,
        enableLocking: true,
        collapsible: false,
        title: 'Expander Rows in a Collapsible Grid with lockable columns',
        header: false,
        emptyText: 'No data yet - please click on one of the tasks at the left',
        iconCls: 'icon-grid',
        margin: '0 0 20 0',
        plugins: [rowEditing],
        features: [{
            ftype: 'summary',
            dock: 'bottom'
        }],

        // reference to controller
        hourController: null,		// Reference to main controller
        columns: [
            {
                text: 'Project',
                flex: 1,
                dataIndex: 'main_project_id',
                renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
                    var main_project_id = record.get('main_project_id');
                    var projectModel = projectStore.getById(main_project_id);
                    if (!projectModel) return "";
                    return projectModel.get('project_name');
                },
                editor: {
                    xtype: 'combo',
                    queryMode: 'local',
                    store: projectStore,
                    displayField: 'project_name',
                    valueField: 'project_id',
                    matchFieldWidth: false,
                    displayTpl: Ext.create('Ext.XTemplate', '<tpl for=".">', '{project_name}', '</tpl>'),
                    listeners: {
                        change: function(combo, value, oldValue, event) {
                            // ToDo: Replace this hard-wired reference with something more intelligent
                            var controller = hourGrid.hourController;
                            controller.onProjectChanged(value, combo, hourGrid);
                        }
                    }
                }
            }, {
                text: 'Task',
                flex: 1,
                dataIndex: 'project_id',
                renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
                    var taskName = record.get('project_id_deref');
                    if (!!taskName && "" != taskName) return taskName;
                    var taskModel = taskTreeStore.getById(value);
                    if (!taskModel) return "";
                    return taskModel.get('project_name');
                },
                editor: { xtype: 'pocombotree', store: taskTreeStore, queryMode: 'local', displayField: 'project_name', valueField: 'id'}
            },
            {text: "<div align=center>Mon<br>3/29/2021</div>", width: 65, align: "right", dataIndex: 'hours',
	     editor: { xtype: 'numberfield', minValue: 0}, summaryType: sumType, summaryRenderer: sumRenderer},
            {text: "<div align=center>Tue<br>3/30/2021</div>", width: 65, align: "right", dataIndex: 'hours',
	     editor: { xtype: 'numberfield', minValue: 0}, summaryType: sumType, summaryRenderer: sumRenderer},
            {text: "<div align=center>Wed<br>2/31/2021</div>", width: 65, align: "right", dataIndex: 'hours',
	     editor: { xtype: 'numberfield', minValue: 0}, summaryType: sumType, summaryRenderer: sumRenderer},
            {text: "<div align=center>Thu<br>2/31/2021</div>", width: 65, align: "right", dataIndex: 'hours',
	     editor: { xtype: 'numberfield', minValue: 0}, summaryType: sumType, summaryRenderer: sumRenderer},
            {text: "<div align=center>Fri<br>2/31/2021</div>", width: 65, align: "right", dataIndex: 'hours',
	     editor: { xtype: 'numberfield', minValue: 0}, summaryType: sumType, summaryRenderer: sumRenderer},
            {text: "<div align=center>Sat<br>2/31/2021</div>", width: 65, align: "right", dataIndex: 'hours',
	     editor: { xtype: 'numberfield', minValue: 0}, summaryType: sumType, summaryRenderer: sumRenderer},
            {text: "<div align=center>Sun<br>2/31/2021</div>", width: 65, align: "right", dataIndex: 'hours',
	     editor: { xtype: 'numberfield', minValue: 0}, summaryType: sumType, summaryRenderer: sumRenderer},
            { text: "Sum", width: 65, dataIndex: 'note', align: "center",
              renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
                  var hoursString = record.get('hours');
                  var hoursFloat = parseFloat(hoursString)
                  if ("number" == typeof(hoursFloat)) return Math.round(700.0 * hoursFloat) / 100.0;
                  return "";
              },
              summaryType: function(hourArray, dataIndex) {
                  var sum = 0;
                  for (var i = 0; i < hourArray.length; i++) {
                      var vString = hourArray[i].get("hours");
                      var vFloat = parseFloat(vString);
                      if (!!vFloat) sum = sum + vFloat;
                  }
                  return sum;
              },
              summaryRenderer: function(value, summaryData, dataIndex) {
                  var type = typeof(value);
                  if ("number" == type) {
                      return Math.round(7.0 * value * 100) / 100;
                  }
                  return value;
              }
            }
        ]
    });

    // -----------------------------------------------------------------------
    // Use the button panel as a container for the task tree and the hour grid
    //
    var hourButtonPanel = Ext.create('Ext.panel.Panel', {
        renderTo: '@task_editor_id@',
        resizable: true,					// Add handles to the panel, so the user can change size
        layout: 'border',
	items: [hourGrid],
        tbar: [{
            icon: '/intranet/images/navbar_default/add.png',
            tooltip: '<%= [lang::message::lookup "" intranet-timesheet2-weekly.Manual_logging "Manual logging"] %>',
            id: 'buttonAddEntry',
            disabled: false
        }, {
            icon: '/intranet/images/navbar_default/delete.png',
            tooltip: '<%= [lang::message::lookup "" intranet-timesheet2-weekly.Delete_logging "Delete entry"] %>',
            id: 'buttonDeleteEntry',
            disabled: false
        }, { xtype: 'tbseparator'}, {
            xtype: 'datefield',
            // anchor: '100%',
            // fieldLabel: 'From',
            name: 'from_date',
            value: new Date(),
            maxValue: new Date(),
            format: "Y-W",
            startDay: 1
        }]
    });

    var hourController = Ext.create('PO.tsweekly.HourWeeklyController', {
        'hourButtonPanel': hourButtonPanel,
	'taskTreeStore': taskTreeStore,
        'hourGrid': hourGrid
    });
    hourController.init(this).onLaunch(this);
    hourGrid.hourController = hourController;   // Add reference to hourGrid

    // -----------------------------------------------------------------------
    // Controller to handle size and resizing related events
    //
    var renderDiv = Ext.get("@task_editor_id@");
    var resizeController = Ext.create('PO.controller.ResizeController', {
        debug: PO.Utilities.getDebug('resizeController'),
        redrawPanel: hourButtonPanel,						// panel with redraw() function and needsRedraw variable
        renderDiv: renderDiv,							// container of outerContainer
        outerContainer: hourButtonPanel					// outermost panel with resize border
    }).init();
    resizeController.onLaunch(this);
    resizeController.onResize();						// Set the size of the outer GanttButton Panel
};


// -----------------------------------------------------------------------
// Start the application after loading the necessary stores
//
Ext.onReady(function() {
    Ext.QuickTips.init();
    var debug = PO.Utilities.getDebug('default');
    var taskTreeStore = Ext.create('PO.store.timesheet.TaskTreeStore');
    var hourStore = Ext.create('PO.store.timesheet.HourStore');
    var projectStore = Ext.create('PO.store.project.ProjectMainStore');

    // Use a "store coodinator" in order to launchTimesheetWeeklyLogging() only
    // if all stores have been loaded:
    var coordinator = Ext.create('PO.controller.StoreLoadCoordinator', {
        stores: [
            'hourStore', 
            'projectMainStore'
        ],
        listeners: {
            load: function() {
                if ("boolean" == typeof this.loadedP) { return; }
                launchTimesheetWeeklyLogging();
                this.loadedP = true;
            }
        }
    });

    // Load stores that need parameters
    taskTreeStore.getProxy().extraParams = { project_id: 0 }; // Load an empty tree
    taskTreeStore.load({
        callback: function(records, operation, success) {
            var me = this;
            if (debug) console.log('PO.store.timesheet.TaskTreeStore: loaded');
            if (!success) {
                PO.Utilities.reportStoreError("TaskTreeStore", operation);
                return;
            }
            var mainProjectNode = records[0];
	    if (mainProjectNode) {
		mainProjectNode.set('sort_order','0');
		me.setRootNode(mainProjectNode);
	    } else {
		me.setRootNode({id: 'root', text: 'Root', project_name: 'Root'});
	    }
        }
    });

    // Load stores that need parameters
    hourStore.getProxy().extraParams = { query: "user_id = @current_user_id@ and day > '2021-03-10'", format: 'json', deref_p: 1 };
    hourStore.load({
        callback: function() {
            console.log('PO.store.timesheet.HourStore: loaded');
        }
    });

    // Load stores that need parameters
    // projectStore.getProxy().extraParams = { query: 'parent_id is NULL and project_status_id = 76', format: 'json' };
    projectStore.getProxy().extraParams = { query: 'parent_id is NULL and (project_status_id in (select * from im_sub_categories(76)) OR \
parent_id is null)', format: 'json' };
    projectStore.load({
        callback: function() {
            console.log('PO.store.project.ProjectMainStore: loaded');
        }
    });
});
</script>
</div>


